import java.awt.*;
import javax.swing.*;

/**
 * <b>Programm:</b> WaveGradient<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert, Milan Altenburg<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> This JPanel uses a GridbagLayout to layout the components and
 * gives a convinient method to add components
 */
class ManagedPanel extends JPanel{
  GridBagLayout grid_bag_layout;

  /**
   * Constructor
   */
  public ManagedPanel(){
    super();
    grid_bag_layout = new GridBagLayout();
    setLayout(grid_bag_layout);
  }

  /**
   * Constructor with minimal size
   */
  public ManagedPanel(int x_coord, int y_coord){
    super();
    grid_bag_layout = new GridBagLayout();
    setLayout(grid_bag_layout);
    setMinimumSize(new Dimension(x_coord,y_coord));
  }


  /**
   * adds a component to the Layout at specified position
   */
  public void addComponent(Component comp,
                           int row, int col,
                           int rowspan, int colspan,
                           double rowweight, double colweight ){

    GridBagConstraints constraints = new GridBagConstraints();
    constraints.fill = constraints.BOTH;
    constraints.anchor = constraints.NORTH;
    constraints.gridx = row;
    constraints.gridy = col;
    constraints.gridwidth = rowspan;
    constraints.gridheight = colspan;
    constraints.weightx = rowweight;
    constraints.weighty = colweight;

    add(comp);
    grid_bag_layout.setConstraints(comp, constraints);
  }
}
