import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
/**
 * <b>Programm:</b> WaveJNI<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert, Milan Altenburg<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> holds Sliders and enable Checkbox for values of MonoWave
 *              and implements needed Listeners
 */

public class MonoWaveSlider implements ChangeListener,
                                       ActionListener {
  FloatJSlider jsAmplitude = null;
  FloatJSlider jsFrequency = null;
  FloatJSlider jsWavelength= null;
  FloatJSlider jsPhase     = null;
  JCheckBox    jcEnabled   = null;
  MonoWave _mw = null;
  
  /**
   * Constructor
   */
  public MonoWaveSlider(MonoWave mw) {
    _mw = mw;
    jsAmplitude = new FloatJSlider();
    jsAmplitude.setName("Amplitude");
    jsAmplitude.addChangeListener(this);
    jsFrequency = new FloatJSlider();
    jsFrequency.setName("Frequency");
    jsFrequency.addChangeListener(this);
    jsWavelength= new FloatJSlider();
    jsWavelength.setName("WaveLength");
    jsWavelength.addChangeListener(this);
    jsPhase     = new FloatJSlider();
    jsPhase.setName("Phase");
    jsPhase.addChangeListener(this);
    jcEnabled = new JCheckBox("on",true);
    jcEnabled.addActionListener(this);
  }
  
  /**
   * returns EnableCheckbox
   */
  public JCheckBox getEnableCheckbox() {
    return( jcEnabled );
  }
  
  /**
   * returns Slider
   */
  public FloatJSlider getAmplitudeSlider() {
    return( jsAmplitude );
  }
    
  /**
   * returns Slider
   */
  public FloatJSlider getFrequencySlider() {
    return( jsFrequency );
  }
    
  /**
   * returns Slider
   */
  public FloatJSlider getWaveLengthSlider() {
    return( jsWavelength );
  }
    
  /**
   * returns Slider
   */
  public FloatJSlider getPhaseSlider() {
    return( jsPhase );
  }

  /**
   * Eventhandler
   */
  public void stateChanged(ChangeEvent e) {
    String name = ((JSlider) e.getSource()).getName();
    if ( name == "Frequency" ){
      _mw.setFrequency(jsFrequency.getFloatValue());
    } else if ( name == "Phase" ){
      _mw.setPhase(jsPhase.getFloatValue());
    } else if ( name == "Amplitude" ){
      _mw.setAmplitude(jsAmplitude.getFloatValue());
    } else if ( name == "WaveLength" ){
      _mw.setWaveLength(jsWavelength.getFloatValue());
    }
  }

  /**
   * Eventhandler
   */
  public void actionPerformed(ActionEvent e) {
    _mw.enable(jcEnabled.isSelected());
  }
}
