import java.util.*;

/**
 * <b>Programm:</b> WaveThread<br>
 * <b>Copyright:</b> 2002 Andreas Gohr, Frank Schubert, Milan Altenburg<br>
 * <b>License:</b> GPL2 or higher<br>
 * <br>
 * <b>Info:</b> thread that calls repaint if queue has elements
 */
public class PullThread extends Thread{
  Painting _paint_area = null;
  CalcThread _calc_thread = null;
  int _width;
  int _height;

  /**
   * Constructor (starts Thread)
   */
  public PullThread(Painting paint_canvas,CalcThread cl_thread) {
    _paint_area = paint_canvas;
    _calc_thread = cl_thread;
    this.start();
  }

  /**
   * "main" of PullThread
   * calls repaint of Painting if queue has elements
   */
  public void run() {
    while(true) {
      // wait for calcthread
      synchronized(_calc_thread) {
        while(_calc_thread.getQueueSize() < 1) {
          try{
            _calc_thread.wait(); // notified by CalcThread
          }catch(InterruptedException int_exception) { }
        }
      }
      // otherwise repaint!
      _paint_area.repaint();
    }
  }
}
