#!/bin/sh

TARGET=WaveJNI

#clean up old stuff
rm -f *.class
rm -f *.jar
rm -f doc/*

#create zip-file
zip $TARGET.zip *.java *.sh *.bat *.c *.h

#create docs
javadoc -d doc *.java

#compile
gcc -shared -o libCalcThread.so CalcThread.c
javac *.java


if ! test -d "META-INF"
then
  mkdir META-INF
fi

if ! test -e "META-INF/MANIFEST.MF"
then
  echo -e "Manifest-Version: 1.0\nCreated-By: 1.4.0_02 (Sun Microsystems Inc.)\nMain-Class: $TARGET" >META-INF/MANIFEST.MF
fi

#create jar
jar -cvmf META-INF/MANIFEST.MF $TARGET.jar *.class *.so *.dll

